include('utils/utils.js');
include('utils/select.js');
include('utils/hof.js');

Window.textVisible=false;

var volcanoPng=loadImage('art/volcano.png',64);
var IMAGES=true;

var board=new Map(5,5,64);
Window.map=board;

var Goal=makeTypeFactory('goal',{shape:'cross',color:'green'});
var Ungoal=makeTypeFactory('ungoal',{shape:'cross',color:'red'});
var Empty=makeTypeFactory('empty',{file:volcanoPng,num:6});
var Cap=makeTypeFactory('cap',{file:volcanoPng,num:5});

var LAYOUT=[
	[0, 0, 0, 1, 2],
	[0, 1, 1, 2, 3],
	[0, 1, 2, 3, 4],
	[1, 2, 3, 3, 4],
	[2, 3, 4, 4, 4]
]

if(IMAGES){
	for(var y=0;y<board.height;y++){
		for(var x=0;x<board.width;x++){
			board.spaces[x][y]={file:volcanoPng,num:LAYOUT[y][x]};
		}
	}
}

withSelect(board);
withInBounds(board);
withNeighbors(board);
withSpacesHaving(board);
withTypeAt(board);

///////////////////////////////
var selected=null; // selected piece

// g8421001170000000400
///////////////////////////////

include('kataSidebar.js');

var recolor=(IMAGES?
	function(cap){
		if(goalAt(cap)){cap.details.num=5}
		else if(ungoalAt(cap)){cap.details.num=5}
		else{cap.details.num=5;}
		cap.repaint();		
	}:
	function (cap){
		if(goalAt(cap)){cap.details.color='green'}
		else if(ungoalAt(cap)){cap.details.color='red'}
		else{cap.details.color='black';}
		cap.repaint();
	});

function typeAt(type){
	return function(x,y){
		if(typeof x != 'number'){
			y=x.y;x=x.x;
		}
		if(board.inBounds(x,y)){
			var pcs=board.pieces(x,y);
			for(var i=0;i<pcs.length;i++){
				if(pcs[i].type==type){
					return pcs[i];
				}
			}
		}
		return null;
	}
}

var capAt=typeAt('cap');
var goalAt=typeAt('goal');
var ungoalAt=typeAt('ungoal');
var emptyAt=typeAt('empty');

board.onclick=function(x,y,b){ // only called when not in a select
	if(b==2)return; // ignore right click
	var cap=capAt(x,y);
	if(cap){
		if(cap.moving)return;
		selected=cap;
		var moves=findMoves(x,y);
		if(moves.length>0){
			board.select(moves);
		}
	}
}

board.onselect=function(x,y){
	if(!selected){print('Somehow, selected is null, yet onselect was called.');}
	selected.moving=true;
	selected.onanimate=function(event){
		if(event=='end'){ // done animating
			this.moving=false;
			recolor(this);
		}
	}
	selected.move(x,y);
	selected=null;
}

board.breakSelect=function(x,y,b){ // called during a select
	return b!=1; // break out if a right click
}

function findMoves(x,y){
	var n=board.neighbors(x,y,true);
	return filter(n,function(c){
		return validMove(coord(x,y),c);
	})
}

function pc(c){
	print('('+c.x+', '+c.y+')');
}

function blocked(c){ // either it's off the edge or there's a cap there
	return !board.inBounds(c) || capAt(c)!=null;
}

function validMove(a,b){
	var c=along(b,delta(a,b)); // the next space in that direction
	return !blocked(b) && (blocked(c) || emptyAt(a)); // no cap on b, but either a cap (or edge) on c, or a is an empty
}

setupPuzzle(codeInput.value);