include('utils/encode.js');
include('editor.js');

var sidebar=new Sidebar();

Window.sidebar=sidebar;

var codeInput={type:'input',
	value:'g8421-00117',
	onaction:setupPuzzle};

var slot=0;
var editorSlot=null;
var editorShown=false;

sidebar[slot++]={type:'space'};

sidebar[slot++]=codeInput;

sidebar[slot++]={type:'button',
	label:'Set up puzzle',
	onclick:function(){setupPuzzle(codeInput.value);}};
	
sidebar[slot++]={type:'button',
	label:'Get puzzle code',
	onclick:function(){
		codeInput.value=getPuzzleCode();
		sidebar.repaint();
	}};

sidebar[slot++]={type:'space'};

editorSlot=slot;
sidebar[slot++]={type:'space'};

sidebar[slot++]={type:'button',
	label:'Enter editor mode',
	onclick:function(){
		if(!editorShown){
			sidebar[editorSlot]=editor;
			editorShown=true;
			enterEditorMode();
			this.label='Leave editor mode';			
		}else{
			sidebar[editorSlot]={type:'space'};
			editorShown=false;
			leaveEditorMode();
			this.label='Enter editor mode';
		}
		sidebar.repaint();
	}};

function setupPuzzle(code){
	code=code||this.value;
	
	var caps='00000';
	var goals='00000';
	var empties='00000';
	var ungoals='00000';
	
	if(code.length>=5)caps=code.substring(0,5);
	if(code.length>=11)goals=code.substring(6,11);
	if(code.length>=17)empties=code.substring(12,17);
	if(code.length>=23)ungoals=code.substring(18,23);
	
	caps=decode(caps);
	goals=decode(goals);
	empties=decode(empties);
	ungoals=decode(ungoals);

	for(var y=0;y<board.height;y++){
		for(var x=0;x<board.width;x++){
			var pcs=board.pieces(x,y);
			for(var p=0;p<pcs.length;p++){
				board.remove(pcs[p]);
			}
		}
	}
	
	
	for(var n=0;n<25;n++){
		var x=n%board.width;
		var y=Math.floor(n/board.width);
		if(empties[n]){
			board.place(new Empty(),x,y);
		}
		if(goals[n]){
			board.place(new Goal(),x,y);
		}
		if(ungoals[n]){
			board.place(new Ungoal(),x,y);
		}
		if(caps[n]){
			var c=new Cap();
			board.place(c,x,y);
			recolor(c);
		}
	}
	
}

function getPuzzleCode(){
	var encodeType=function(map,type){
		var c='';
		for(var y=0;y<map.height;y++){
			var row=[];
			
			for(var x=0;x<map.width;x++){
				row.push(map.typeAt(type,x,y)!=null);
			}
			
			c+=encode(row);
		}
		return c;
	}
	
	var types=['cap','goal','empty','ungoal'];
	var code='';
	for(var i=0;i<types.length;i++){
		var str=encodeType(board,types[i]);
		if(str=='00000')continue;
		if(code!='')code+='-';
		code+=str;
	}

	return code;
}